My heart goes out to shell programmers who have to support posix sh
Explanation for newbies:
Shell is the programming language that you use when you open a terminal on linux or mac os. Well, actually "shell" is a family of languages with many different implementations (bash, dash, ash, zsh, ksh, fish, ....)
Writing programs in shell (called "shell scripts") is a harrowing experience because the language is optimized for interactive use at a terminal, not writing extensive applications
The two lines in the meme change the shell's behavior to be slightly less headache-inducing for the programmer:
set -euo pipefail is the short form of the following three commands:
set -e: exit on the first command that fails, rather than plowing through ignoring all errors
set -u: treat references to undefined variables as errors
set -o pipefail: If a command piped into another command fails, treat that as an error
export LC_ALL=C tells other programs to not do weird things depending on locale. For example, it forces seq to output numbers with a period as the decimal separator, even on systems where coma is the default decimal separator (russian, dutch, etc.).
The title text references "posix", which is a document that standardizes, among other things, what features a shell must have. Posix does not require a shell to implement pipefail, so if you want your script to run on as many different platforms as possible, then you cannot use that feature.
It is different in spoken form, written form (chat) and written as a post (like here).
In person, you get a reaction almost immediately. Written as a short chat, you also get a reaction. But like this is more of an accessibility thing rather than the joke not being funny. You know, like those text descriptions of an image (usually for memes).
set -euo pipefail is, in my opinion, an antipattern. This page does a really good job of explaining why. pipefail is occasionally useful, but should be toggled on and off as needed, not left on. IMO, people should just write shell the way they write go, handling every command that could fail individually. it's easy if you write a die function like this:
die () {
message="$1"; shift
return_code="${1:-1}"
printf '%s\n' "$message" 1>&2
exit "$return_code"
}
# we should exit if, say, cd fails
cd /tmp || die "Failed to cd /tmp while attempting to scrozzle foo $foo"
# downloading something? handle the error. Don't like ternary syntax? use if
if ! wget https://someheinousbullshit.com/"$foo"; then
die "failed to get unscrozzled foo $foo"
fi
It only takes a little bit of extra effort to handle the errors individually, and you get much more reliable shell scripts. To replace -u, just use shellcheck with your editor when writing scripts. I'd also highly recommend https://mywiki.wooledge.org as a resource for all things POSIX shell or Bash.
The issue with set -e is that it's hideously broken and inconsistent. Let me copy the examples from the wiki I linked.
Or, "so you think set -e is OK, huh?"
Exercise 1: why doesn't this example print anything?
#!/usr/bin/env bash
set -e
i=0
let i++
echo "i is $i"
Exercise 2: why doesthisone sometimes appear to work? In which versions of bash does it work, and in which versions does it fail?
#!/usr/bin/env bash
set -e
i=0
((i++))
echo "i is $i"
Exercise 3: why aren't these two scripts identical?
#!/usr/bin/env bash
set -e
test -d nosuchdir && echo no dir
echo survived
#!/usr/bin/env bash
set -e
f() { test -d nosuchdir && echo no dir; }
f
echo survived
Exercise 4: why aren'tthesetwo scripts identical?
set -e
f() { test -d nosuchdir && echo no dir; }
f
echo survived
set -e
f() { if test -d nosuchdir; then echo no dir; fi; }
f
echo survived
Exercise 5: under what conditions will this fail?
set -e
read -r foo < configfile
And now, back to your regularly scheduled comment reply.
set -e would absolutely be more elegant if it worked in a way that was easy to understand. I would be shouting its praises from my rooftop if it could make Bash into less of a pile of flaming plop. Unfortunately , set -e is, by necessity, a labyrinthian mess of fucked up hacks.
Let me leave you with a allegory about set -e copied directly from that same wiki page. It's too long for me to post it in this comment, so I'll respond to myself.
After tens of thousands of bash lines written, I have to disagree. The article seems to argue against use of -e due to unpredictable behavior; while that might be true, I've found having it in my scripts is more helpful than not.
Bash is clunky. -euo pipefail is not a silver bullet but it does improve the reliability of most scripts. Expecting the writer to check the result of each command is both unrealistic and creates a lot of noise.
When using this error handling pattern, most lines aren't even for handling them, they're just there to bubble it up to the caller. That is a distraction when reading a piece of code, and a nuisense when writing it.
For the few times that I actually want to handle the error (not just pass it up), I'll do the "or" check. But if the script should just fail, -e will do just fine.
Yeah, while -e has a lot of limitations, it shouldn't be thrown out with the bathwater. The unofficial strict mode can still de-weird bash to an extent, and I'd rather drop bash altogether when they're insufficient, rather than try increasingly hard to work around bash's weirdness. (I.e. I'd throw out the bathwater, baby and the family that spawned it at that point.)
This is why I made the reference to Go. I honestly hate Go, I think exceptions are great and very ergonomic and I wish that language had not become so popular. However, a whole shitload of people apparently disagree, hence the popularity of Go and the acceptance of its (imo) terrible error handling. If developers don't have a problem with it in Go, I don't see why they'd have a problem with it in Bash. The error handling is identical to what I posted and the syntax is shockingly similar. You must unpack the return of a func in Go if you're going to assign, but you're totally free to just assign an err to _ in Go and be on your way, just like you can ignore errors in Bash. The objectively correct way to write Go is to handle every err that gets returned to you, either by doing something, or passing it up the stack (and possibly wrapping it). It's a bunch of bubbling up. My scripts end up being that way too. It's messy, but I've found it to be an incredibly reliable strategy. Plus, it's really easy for me to grep for a log message and get the exact line where I encountered an issue.
This is all just my opinion. I think this is one of those things where the best option is to just agree to disagree. I will admit that it irritates me to see blanket statements saying "your script is bad if you don't set -euo pipefail", but I'd be totally fine if more people made a measured recommendation like you did. I likely will never use set -e, but if it gets the bills paid for people then that's fine. I just think people need to be warned of the footguns.
EDIT: my autocorrect really wanted to fuck up this comment for some reason. Apologies if I have a dumb number of typos.
I was tempted for years to use it as an occasional try/catch, but learning Go made me realize that exceptions are amazing and I miss them, but that it is possible (but occasionally hideously tedious) to write software without them. Like, I feel like anyone who has written Go competently (i.e. they handle every returned err on an individual or aggregated basis) should be able to write relatively error-handled shell. There are still the billion other footguns built directly into bash that will destroy hopes and dreams, but handling errors isn't too bad if you just have a little die function and the determination to use it.
Lol, I love that someone made this. What if your input has newlines tho, gotta use that NUL terminator!
God, I wish more tools had nice NUL-separated output. Looking at you, jq. I dunno why this issue has been open for so long, but it hurts me. Like, they've gone back and forth on this so many times...
My only issue is -u. How do you print help text if your required parameters are always filled. There's no way to test for -z if the shell bails on the first line.
Edit: though I guess you could initialise your vars with bad defaults, and test for those.
Shell is great, but if you're using it as a programming language then you're going to have a bad time. It's great for scripting, but if you find yourself actually programming in it then save yourself the headache and use an actual language!
Alpine linux, one of the most popular distros to use inside docker containers (and arguably good for desktop, servers, and embedded) is held together by shell scripts, and it's doing just fine. The installer, helper commands, and init scripts are all written for busybox sh. But I guess that falls under "scripting" by your definition.
I learned about it the hard way lol. seq used to generate a csv file in a script. My polish friend runs said script, and suddenly there's an extra column in the csv...
Nushell has pipefail by default (plus an actual error system that integrates with status codes) and has actual number values, don't have these problems
I was never a fan of set -e. I prefer to do my own error handling. But, I never understood why pipefail wasn't the default. A failure is a failure. I would like to know about it!
Yeah, I had a silly hack for that. I don't remember what it was. It's been 3-4 years since I wrote bash for a living. While not perfect, I still need to know if a pipeline command failed. Continuing a script after an invisible error, in many cases, could have been catastrophic.
People call set -euo pipefail strict mode but, it's just another footgun in a language full of footguns. Shellcheck is a fucking blessing from heaven though. I wish I could forcibly install it on every developer's system.
If you have some particular and complicated task then sure you'd probably write a program for it in a specific high-level language. But that isn't what the shell is for.
If you've already got a bunch of apps and utilities and want to orchestrate them together to do a task, that's a good shell use case.
Or if you have a system that needs setup and install tasks doing on it to prepare for running your actual workload, that's also a task which the shell is ideally suited to.
Shell scripting always has a place, and I can't see it being made obsolete any time soon.
People keep on telling me that python is a "scripting language" but honestly I would rather use the shoddiest and most barebones shell you would give me than python if I had to make a script. It all boils to interfaces, and there are more programs, libraries, and daemons that have a shell interface as opposed to whatever other "better" language there is out there. Trying to write scripts with Python or ruby or whatever will just boils down to plumbing data between external programs in a less succinct syntax. What good is type safety, try/catch, and classes if all the tools that you're using are taking in and spitting out raw text anyway?
Better would be to leave the 1970s and never interact with a terminal again…
I'm still waiting for someone to come up with a better alternative. And once someone does come up with something better, it will be another few decades of waiting for it to catch on. Terminal emulation is dumb and weird, but there's just no better solution that's also compatible with existing software. Just look at any IDE as an example: visual studio, code blocks, whatever. Thousands of hours put into making all those fancy buttons menus and GUIs, and still the only feature that is worth using is the built-in terminal emulator which you can use to run a real text editor like vim or emacs.
The .net-ification of *nix just seems bonkers to me.
It IS bonkers. As a case study, compare the process of setting up a self-hosted runner in gitlab vs github.
Gitlab does everything The Linux Way. You spin up a slim docker container based on Alpine, pass it the API key, and you're done. Nice and simple.
Github, being owned by Microsoft, does everything The Microsoft way. The documentation mentions nothing of containers, you're just meant to run the runner natively, essentially giving Microsoft and anyone else in the repo a reverse shell into your machine. Lovely. Microsoft then somehow managed to make their runner software (reminder: whose entire job consists of pulling a git repo, parsing a yaml file, and running some shell commands) depend on fucking dotnet and a bunch of other bullshit. You're meant to install it using a shitty setup.sh script that does that stupid thing with detecting what distro you're on and calling the native package manager to install dependencies. Which of course doesn't work for shit for anyone who's not on debain or fedora because those are the only distro's they've bothered with. So you're either stuck setting up dotnet on your system, or trying to manually banish this unholy abomination into a docker container, which is gonna end up twice the size of gitlab's pre-made Alpine container thanks to needing glibc to run dotnet (and also full gnu coreutils for some fucking reason)
Bloat is just microsoft's way of doing things. They see unused resources, and they want to use them. Keep microsoft out of linux.
What type of .net-ification occurs on *nix?
I am current linux "admin" and there is close to 0 times where I've seen powershell not on windows. Maybe in some microsoft specific hell-scape it is more common, but it's hard to imagine that there are people that can accept a "shell" that takes 5-10 seconds to start. There are apps written in c# but they aren't all that common?
p.communicate() will take a string (or bytes) and send it to the stdin of the process, then wait for p to finish execution
there are ways to stream input into a running process (without waiting for the process to finish), but I don't remember how off the top of my head
from shutil import which
from subprocess import Popen, PIPE, run
from pathlib import Path
LS = which('ls')
REV = which('rev')
ls = run([LS, Path.home()], stdout=PIPE)
p = Popen([REV], stdin=PIPE, stdout=PIPE)
stdout, stderr = p.communicate(ls.stdout)
print(stdout.decode('utf-8'))
No, sorry. I'm a python dev and I love python, but there's no way I'm using it for scripting. Trying to use python as a shell language just has you passing data across Popen calls with a sea of .decode and .encode. You're doing the same stuff you would be doing in shell, but with a less concise syntax. Literally all of python's benefits (classes, types, lists) are negated because all of the tools you're using when writing scripts are processing raw text anyway. Not to mention the version incompatibility thing. You use an f-string in a spicy way once, and suddenly your "script" is incompatible with half of all python installations out there, which is made worse by the fact that almost every distro has a very narrow selection of python versions available on their package manager. With shell you have the least common denominator of posix sh. With Python, some distros rush ahead to the latest release, while other hang on to ancient versions. Even print("hello world") isn't guaranteed to work, since some LTS ubuntu versions still have python pointing to python2.
The quickest cure for thinking that Python "solves" the problems of shell is to first learn good practices of shell, and then trying to port an existing shell script to python. That'll change your opinion quickly enough.